/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.cpp																			  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "MainWindow.h"
#include "Game.h"

Game::Game(MainWindow& wnd)
	:
	wnd(wnd),
	gfx(wnd)
{
}

void Game::Go()
{
	gfx.BeginFrame();
	UpdateModel();
	ComposeFrame();
	gfx.EndFrame();
}

// Fix: 
//		Nothing right now
// Implement: 
//		Make points do something
//		Visual counter for score
//		Show visual when you get a point

void Game::Dude(int x, int y, int r, int g, int b)
{
	if (Lives > 0)
	{
		gfx.PutPixel(x    , y    , r, g, b);
		gfx.PutPixel(x + 1, y    , r, g, b);
		gfx.PutPixel(x + 2, y    , r, g, b);
		gfx.PutPixel(x + 3, y    , r, g, b);
		gfx.PutPixel(x + 4, y    , r, g, b);
		gfx.PutPixel(x + 5, y    , r, g, b);
		gfx.PutPixel(x + 6, y    , r, g, b);
		gfx.PutPixel(x + 7, y    , r, g, b);
		gfx.PutPixel(x + 8, y    , r, g, b);
		gfx.PutPixel(x + 9, y    , r, g, b);
		gfx.PutPixel(x    , y + 1, r, g, b);
		gfx.PutPixel(x    , y + 2, r, g, b);
		gfx.PutPixel(x    , y + 3, r, g, b);
		gfx.PutPixel(x    , y + 4, r, g, b);
		gfx.PutPixel(x    , y + 5, r, g, b);
		gfx.PutPixel(x    , y + 6, r, g, b);
		gfx.PutPixel(x    , y + 7, r, g, b);
		gfx.PutPixel(x    , y + 8, r, g, b);
		gfx.PutPixel(x    , y + 9, r, g, b);
		gfx.PutPixel(x + 9, y + 1, r, g, b);
		gfx.PutPixel(x + 9, y + 2, r, g, b);
		gfx.PutPixel(x + 9, y + 3, r, g, b);
		gfx.PutPixel(x + 9, y + 4, r, g, b);
		gfx.PutPixel(x + 9, y + 5, r, g, b);
		gfx.PutPixel(x + 9, y + 6, r, g, b);
		gfx.PutPixel(x + 9, y + 7, r, g, b);
		gfx.PutPixel(x + 9, y + 8, r, g, b);
//		gfx.PutPixel(x + 9, y + 9, r, g, b);
		gfx.PutPixel(x + 1, y + 9, r, g, b);
		gfx.PutPixel(x + 2, y + 9, r, g, b);
		gfx.PutPixel(x + 3, y + 9, r, g, b);
		gfx.PutPixel(x + 4, y + 9, r, g, b);
		gfx.PutPixel(x + 5, y + 9, r, g, b);
		gfx.PutPixel(x + 6, y + 9, r, g, b);
		gfx.PutPixel(x + 7, y + 9, r, g, b);
		gfx.PutPixel(x + 8, y + 9, r, g, b);
		gfx.PutPixel(x + 9, y + 9, r, g, b);
	}
}

void Game::Boss(int x, int y, int r, int g, int b)
{
	if (Lives > 0)
	{
		gfx.PutPixel(x     , y     , r, g, b);
		gfx.PutPixel(x + 1 , y     , r, g, b);
		gfx.PutPixel(x + 2 , y     , r, g, b);
		gfx.PutPixel(x + 3 , y     , r, g, b);
		gfx.PutPixel(x + 4 , y     , r, g, b);
		gfx.PutPixel(x + 5 , y     , r, g, b);
		gfx.PutPixel(x + 6 , y     , r, g, b);
		gfx.PutPixel(x + 7 , y     , r, g, b);
		gfx.PutPixel(x + 8 , y     , r, g, b);
		gfx.PutPixel(x + 9 , y     , r, g, b);
		gfx.PutPixel(x + 10, y     , r, g, b);
		gfx.PutPixel(x + 11, y     , r, g, b);
		gfx.PutPixel(x + 12, y     , r, g, b);
		gfx.PutPixel(x + 13, y     , r, g, b);
		gfx.PutPixel(x + 14, y     , r, g, b);
		gfx.PutPixel(x + 15, y     , r, g, b);
		gfx.PutPixel(x + 16, y     , r, g, b);
		gfx.PutPixel(x + 17, y     , r, g, b);
		gfx.PutPixel(x     , y + 1 , r, g, b);
		gfx.PutPixel(x     , y + 2 , r, g, b);
		gfx.PutPixel(x     , y + 3 , r, g, b);
		gfx.PutPixel(x     , y + 4 , r, g, b);
		gfx.PutPixel(x     , y + 5 , r, g, b);
		gfx.PutPixel(x     , y + 6 , r, g, b);
		gfx.PutPixel(x     , y + 7 , r, g, b);
		gfx.PutPixel(x     , y + 8 , r, g, b);
		gfx.PutPixel(x     , y + 9 , r, g, b);
		gfx.PutPixel(x     , y + 10, r, g, b);
		gfx.PutPixel(x     , y + 11, r, g, b);
		gfx.PutPixel(x     , y + 12, r, g, b);
		gfx.PutPixel(x     , y + 13, r, g, b);
		gfx.PutPixel(x     , y + 14, r, g, b);
		gfx.PutPixel(x     , y + 15, r, g, b);
		gfx.PutPixel(x     , y + 16, r, g, b);
		gfx.PutPixel(x     , y + 17, r, g, b);
		gfx.PutPixel(x + 17, y + 1 , r, g, b);
		gfx.PutPixel(x + 17, y + 2 , r, g, b);
		gfx.PutPixel(x + 17, y + 3 , r, g, b);
		gfx.PutPixel(x + 17, y + 4 , r, g, b);
		gfx.PutPixel(x + 17, y + 5 , r, g, b);
		gfx.PutPixel(x + 17, y + 6 , r, g, b);
		gfx.PutPixel(x + 17, y + 7 , r, g, b);
		gfx.PutPixel(x + 17, y + 8 , r, g, b);
		gfx.PutPixel(x + 17, y + 9 , r, g, b);
		gfx.PutPixel(x + 17, y + 10, r, g, b);
		gfx.PutPixel(x + 17, y + 11, r, g, b);
		gfx.PutPixel(x + 17, y + 12, r, g, b);
		gfx.PutPixel(x + 17, y + 13, r, g, b);
		gfx.PutPixel(x + 17, y + 14, r, g, b);
		gfx.PutPixel(x + 17, y + 15, r, g, b);
		gfx.PutPixel(x + 17, y + 16, r, g, b);
		//	gfx.PutPixel(x + 17, y + 17, r, g, b);
		gfx.PutPixel(x + 1 , y + 17, r, g, b);
		gfx.PutPixel(x + 2 , y + 17, r, g, b);
		gfx.PutPixel(x + 3 , y + 17, r, g, b);
		gfx.PutPixel(x + 4 , y + 17, r, g, b);
		gfx.PutPixel(x + 5 , y + 17, r, g, b);
		gfx.PutPixel(x + 6 , y + 17, r, g, b);
		gfx.PutPixel(x + 7 , y + 17, r, g, b);
		gfx.PutPixel(x + 8 , y + 17, r, g, b);
		gfx.PutPixel(x + 9 , y + 17, r, g, b);
		gfx.PutPixel(x + 10, y + 17, r, g, b);
		gfx.PutPixel(x + 11, y + 17, r, g, b);
		gfx.PutPixel(x + 12, y + 17, r, g, b);
		gfx.PutPixel(x + 13, y + 17, r, g, b);
		gfx.PutPixel(x + 14, y + 17, r, g, b);
		gfx.PutPixel(x + 15, y + 17, r, g, b);
		gfx.PutPixel(x + 16, y + 17, r, g, b);
		gfx.PutPixel(x + 17, y + 17, r, g, b);
	}
}

void Game::Running()
{
	if (RunLength == 0)
	{
		if (wnd.kbd.KeyIsPressed(VK_SHIFT) && isReady == true)
		{
			isRunning = true;
		}
		Speed = 5;
	}

	if (isRunning)
	{
		if (wnd.kbd.KeyIsPressed(VK_SHIFT))
		{
			Speed = 9;
			RunLength++;
		}
		else if (RunLength > 10) /*implied that shift is no longer pressed*/
		{
			isRunning = false;
			isExhausted = true;
			isReady = false; //will be the check later to make sure they let go of shift before running again
		}
		else /*if RunLength was shorter than 10, then it was barely pressed, and so should not need recovery*/
		{
			isRunning = false;
			RunLength = 0;
		}
	}

	if (RunLength == 100) /*stopping you from running for too long*/
	{
		isRunning = false;
		isExhausted = true;
		isReady = false;
	}
}

void Game::Exhaustion()
{
	if (isExhausted)
	{
		if (ExhaustedStage == 0)
		{
			Speed = 7;
			ExhaustedStage++;
			RunLength -= 3; /*accounting for the ExhaustedStages. Just so recovery time is exactly sprint time*/
			DudeB += 30;
		}
		else if (ExhaustedStage == 1)
		{
			Speed = 5;
			ExhaustedStage++;
			DudeB += 30;
		}
		else if (ExhaustedStage == 2)
		{
			Speed = 3;
			ExhaustedStage++;
			DudeB += 30;
		}
		else
		{
			RunLength--;
		}

		if (RunLength == 2 || RunLength == 1) //less harsh of a colour changeback
		{
			DudeB -= 30;
			Speed = 4;
		}
		if (RunLength == 0)
		{
			isExhausted = false;
			ExhaustedStage = 0;
			DudeB = 100;
		}
	}
	if (isReady == false && RunLength == 0 && (!(wnd.kbd.KeyIsPressed(VK_SHIFT))))
	{
		isReady = true;
	}
}

void Game::Movement(int &x, int &y)
{
	if (isAgainstBorder == false && Lives > 0)
	{
		if (wnd.kbd.KeyIsPressed(VK_SPACE))
		{
			Speed = 1;
		}
		if (wnd.kbd.KeyIsPressed(VK_RIGHT))
		{
			x += Speed;
		}
		if (wnd.kbd.KeyIsPressed(VK_LEFT))
		{
			x -= Speed;
		}
		if (wnd.kbd.KeyIsPressed(VK_DOWN))
		{
			y += Speed;
		}
		if (wnd.kbd.KeyIsPressed(VK_UP))
		{
			y -= Speed;
		}
	}
}

void Game::Borders(int &x, int &y, int w)
{
	if (x < 0)
	{
		x = 0;
	}
	if (y < 0)
	{
		y = 0;
	}
	if (x + w > 799)
	{
		x = 799 - w;
	}
	if (y + w > 599)
	{
		y = 599 - w;
	}
}

void Game::BossMovement(int dx, int dy, int &bx, int &by, int dw, int bw, int rad)
{
	if (dx > bx + bw && dx < bx + bw + rad && dy + dw < by + bw + rad && dy + dw > by - rad)
	{
		bx -= 1;
	}
	if (dx + dw > bx - rad && dx + dw < bx && dy + dw < by + bw + rad && dy + dw > by - rad)
	{
		bx += 1;
	}
	if (dy + dw < by && dy + dw > by - rad && dx + dw > bx - rad && dx < bx + bw + rad)
	{
		by += 1;
	}
	if (dy > by + bw && dy + dw < by + bw + rad && dx + dw > bx - rad && dx < bx + bw + rad)
	{
		by -= 1;
	}
}

void Game::BossMovement_C()
{
	if (isAgainstBorder == false)
	{
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 200);	/*1*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 150);	/*2*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 112);	/*3*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 84);		/*4*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 63);		/*5*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 47);		/*6*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 36);		/*7*/
		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 27);		/*8*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 20);		/*9*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 15);		/*10*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 11);		/*11*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 8);		/*12*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 6);		/*13*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 5);		/*14*/
//		BossMovement(DudeX, DudeY, BossX, BossY, DudeW, BossW, 4);		/*15*/
	}
}

void Game::Teleport()
{
	if (isAgainstBorder && TeleportStage == 0)
	{
		DudeG_Ass = DudeG / 10;  //Here so that you can altar Dude's colour variables and still have him properly fade in/out
	}
	if (isAgainstBorder && TeleportStage < 10)
	{
		DudeR -= 23;
		DudeG -= DudeG_Ass;
		DudeB -= 10;
		BossR -= 16;
		BossG -= 3;
		BossB -= 24;
		ObstacleRGB -= 20;
		TeleportStage++;
	}
	if (TeleportStage == 10)
	{
		DudeX = 45;
		DudeY = 545;
		BossX = 391;
		BossY = 291;
		RandomizeObstacle_C(); //Assigns value of rand to each Obstacle
		DudeColourAssign(); //Changes value of DudeG_Ass depending on Lives
		TeleportStage++;
	}
	if (TeleportStage > 10 && TeleportStage < 21)
	{
		DudeR += 23;
		DudeG += DudeG_Ass;
		DudeB += 10;
		BossR += 16;
		BossG += 3;
		BossB += 24;
		ObstacleRGB += 20;
		TeleportStage++;
	}
	if (TeleportStage == 21)
	{
		TeleportStage = 0;
		isAgainstBorder = false;
	}
}

void Game::BorderCheck(int x, int y, int w)
{
	// The reason you have a BorderCheck, and not just include it in "Border" is so that it doesn't activate when Dude touches border, only when Boss does
	if (x <= 0)
	{
		isAgainstBorder = true;
		isSuccessful = true;
	}
	if (y <= 0)
	{
		isAgainstBorder = true;
		isSuccessful = true;
	}
	if (x + w >= 799)
	{
		isAgainstBorder = true;
		isSuccessful = true;
	}
	if (y + w >= 599)
	{
		isAgainstBorder = true;
		isSuccessful = true;
	}
}

void Game::Obstacle(int x, int y, int r, int g, int b)
{
	//	top
	gfx.PutPixel(x     , y, r, g, b);
	gfx.PutPixel(x + 1 , y, r, g, b);
	gfx.PutPixel(x + 2 , y, r, g, b);
	gfx.PutPixel(x + 3 , y, r, g, b);
	gfx.PutPixel(x + 3 , y, r, g, b);
	gfx.PutPixel(x + 4 , y, r, g, b);
	gfx.PutPixel(x + 5 , y, r, g, b);
	gfx.PutPixel(x + 6 , y, r, g, b);
	gfx.PutPixel(x + 7 , y, r, g, b);
	gfx.PutPixel(x + 8 , y, r, g, b);
	gfx.PutPixel(x + 9 , y, r, g, b);
	gfx.PutPixel(x + 10, y, r, g, b);
	gfx.PutPixel(x + 11, y, r, g, b);
	gfx.PutPixel(x + 12, y, r, g, b);
	gfx.PutPixel(x + 13, y, r, g, b);
	gfx.PutPixel(x + 14, y, r, g, b);
	gfx.PutPixel(x + 15, y, r, g, b);
	gfx.PutPixel(x + 16, y, r, g, b);
	gfx.PutPixel(x + 17, y, r, g, b);
	gfx.PutPixel(x + 18, y, r, g, b);
	gfx.PutPixel(x + 19, y, r, g, b);
	gfx.PutPixel(x + 20, y, r, g, b);
	gfx.PutPixel(x + 21, y, r, g, b);
	gfx.PutPixel(x + 22, y, r, g, b);
	gfx.PutPixel(x + 23, y, r, g, b);
	gfx.PutPixel(x + 24, y, r, g, b);
	gfx.PutPixel(x + 25, y, r, g, b);
	gfx.PutPixel(x + 26, y, r, g, b);
	gfx.PutPixel(x + 27, y, r, g, b);
	gfx.PutPixel(x + 28, y, r, g, b);
	gfx.PutPixel(x + 29, y, r, g, b);
	gfx.PutPixel(x + 30, y, r, g, b);
	//	right
	gfx.PutPixel(x + 30, y + 1 , r, g, b);
	gfx.PutPixel(x + 30, y + 2 , r, g, b);
	gfx.PutPixel(x + 30, y + 3 , r, g, b);
	gfx.PutPixel(x + 30, y + 4 , r, g, b);
	gfx.PutPixel(x + 30, y + 5 , r, g, b);
	gfx.PutPixel(x + 30, y + 6 , r, g, b);
	gfx.PutPixel(x + 30, y + 7 , r, g, b);
	gfx.PutPixel(x + 30, y + 8 , r, g, b);
	gfx.PutPixel(x + 30, y + 9 , r, g, b);
	gfx.PutPixel(x + 30, y + 10, r, g, b);
	gfx.PutPixel(x + 30, y + 11, r, g, b);
	gfx.PutPixel(x + 30, y + 12, r, g, b);
	gfx.PutPixel(x + 30, y + 13, r, g, b);
	gfx.PutPixel(x + 30, y + 14, r, g, b);
	gfx.PutPixel(x + 30, y + 15, r, g, b);
	gfx.PutPixel(x + 30, y + 16, r, g, b);
	gfx.PutPixel(x + 30, y + 17, r, g, b);
	gfx.PutPixel(x + 30, y + 18, r, g, b);
	gfx.PutPixel(x + 30, y + 19, r, g, b);
	gfx.PutPixel(x + 30, y + 20, r, g, b);
	gfx.PutPixel(x + 30, y + 21, r, g, b);
	gfx.PutPixel(x + 30, y + 22, r, g, b);
	gfx.PutPixel(x + 30, y + 23, r, g, b);
	gfx.PutPixel(x + 30, y + 24, r, g, b);
	gfx.PutPixel(x + 30, y + 25, r, g, b);
	gfx.PutPixel(x + 30, y + 26, r, g, b);
	gfx.PutPixel(x + 30, y + 27, r, g, b);
	gfx.PutPixel(x + 30, y + 28, r, g, b);
	gfx.PutPixel(x + 30, y + 29, r, g, b);
	gfx.PutPixel(x + 30, y + 30, r, g, b);
	//	left
	gfx.PutPixel(x, y + 1 , r, g, b);
	gfx.PutPixel(x, y + 2 , r, g, b);
	gfx.PutPixel(x, y + 3 , r, g, b);
	gfx.PutPixel(x, y + 4 , r, g, b);
	gfx.PutPixel(x, y + 5 , r, g, b);
	gfx.PutPixel(x, y + 6 , r, g, b);
	gfx.PutPixel(x, y + 7 , r, g, b);
	gfx.PutPixel(x, y + 8 , r, g, b);
	gfx.PutPixel(x, y + 9 , r, g, b);
	gfx.PutPixel(x, y + 10, r, g, b);
	gfx.PutPixel(x, y + 11, r, g, b);
	gfx.PutPixel(x, y + 12, r, g, b);
	gfx.PutPixel(x, y + 13, r, g, b);
	gfx.PutPixel(x, y + 14, r, g, b);
	gfx.PutPixel(x, y + 15, r, g, b);
	gfx.PutPixel(x, y + 16, r, g, b);
	gfx.PutPixel(x, y + 17, r, g, b);
	gfx.PutPixel(x, y + 18, r, g, b);
	gfx.PutPixel(x, y + 19, r, g, b);
	gfx.PutPixel(x, y + 20, r, g, b);
	gfx.PutPixel(x, y + 21, r, g, b);
	gfx.PutPixel(x, y + 22, r, g, b);
	gfx.PutPixel(x, y + 23, r, g, b);
	gfx.PutPixel(x, y + 24, r, g, b);
	gfx.PutPixel(x, y + 25, r, g, b);
	gfx.PutPixel(x, y + 26, r, g, b);
	gfx.PutPixel(x, y + 27, r, g, b);
	gfx.PutPixel(x, y + 28, r, g, b);
	gfx.PutPixel(x, y + 29, r, g, b);
	gfx.PutPixel(x, y + 30, r, g, b);
	//	bottom
	gfx.PutPixel(x + 1, y + 30 , r, g, b);
	gfx.PutPixel(x + 2, y + 30 , r, g, b);
	gfx.PutPixel(x + 3, y + 30 , r, g, b);
	gfx.PutPixel(x + 3, y + 30 , r, g, b);
	gfx.PutPixel(x + 4, y + 30 , r, g, b);
	gfx.PutPixel(x + 5, y + 30 , r, g, b);
	gfx.PutPixel(x + 6, y + 30 , r, g, b);
	gfx.PutPixel(x + 7, y + 30 , r, g, b);
	gfx.PutPixel(x + 8, y + 30 , r, g, b);
	gfx.PutPixel(x + 9, y + 30 , r, g, b);
	gfx.PutPixel(x + 10, y + 30, r, g, b);
	gfx.PutPixel(x + 11, y + 30, r, g, b);
	gfx.PutPixel(x + 12, y + 30, r, g, b);
	gfx.PutPixel(x + 13, y + 30, r, g, b);
	gfx.PutPixel(x + 14, y + 30, r, g, b);
	gfx.PutPixel(x + 15, y + 30, r, g, b);
	gfx.PutPixel(x + 16, y + 30, r, g, b);
	gfx.PutPixel(x + 17, y + 30, r, g, b);
	gfx.PutPixel(x + 18, y + 30, r, g, b);
	gfx.PutPixel(x + 19, y + 30, r, g, b);
	gfx.PutPixel(x + 20, y + 30, r, g, b);
	gfx.PutPixel(x + 21, y + 30, r, g, b);
	gfx.PutPixel(x + 22, y + 30, r, g, b);
	gfx.PutPixel(x + 23, y + 30, r, g, b);
	gfx.PutPixel(x + 24, y + 30, r, g, b);
	gfx.PutPixel(x + 25, y + 30, r, g, b);
	gfx.PutPixel(x + 26, y + 30, r, g, b);
	gfx.PutPixel(x + 27, y + 30, r, g, b);
	gfx.PutPixel(x + 28, y + 30, r, g, b);
	gfx.PutPixel(x + 29, y + 30, r, g, b);
	gfx.PutPixel(x + 30, y + 30, r, g, b);
	//	diagonal top left-bottom right
	gfx.PutPixel(x + 1 , y + 1 , r, g, b);
	gfx.PutPixel(x + 2 , y + 2 , r, g, b);
	gfx.PutPixel(x + 3 , y + 3 , r, g, b);
	gfx.PutPixel(x + 4 , y + 4 , r, g, b);
	gfx.PutPixel(x + 5 , y + 5 , r, g, b);
	gfx.PutPixel(x + 6 , y + 6 , r, g, b);
	gfx.PutPixel(x + 7 , y + 7 , r, g, b);
	gfx.PutPixel(x + 8 , y + 8 , r, g, b);
	gfx.PutPixel(x + 9 , y + 9 , r, g, b);
	gfx.PutPixel(x + 10, y + 10, r, g, b);
	gfx.PutPixel(x + 11, y + 11, r, g, b);
	gfx.PutPixel(x + 12, y + 12, r, g, b);
	gfx.PutPixel(x + 13, y + 13, r, g, b);
	gfx.PutPixel(x + 14, y + 14, r, g, b);
	gfx.PutPixel(x + 15, y + 15, r, g, b);
	gfx.PutPixel(x + 16, y + 16, r, g, b);
	gfx.PutPixel(x + 17, y + 17, r, g, b);
	gfx.PutPixel(x + 18, y + 18, r, g, b);
	gfx.PutPixel(x + 19, y + 19, r, g, b);
	gfx.PutPixel(x + 20, y + 20, r, g, b);
	gfx.PutPixel(x + 21, y + 21, r, g, b);
	gfx.PutPixel(x + 22, y + 22, r, g, b);
	gfx.PutPixel(x + 23, y + 23, r, g, b);
	gfx.PutPixel(x + 24, y + 24, r, g, b);
	gfx.PutPixel(x + 25, y + 25, r, g, b);
	gfx.PutPixel(x + 26, y + 26, r, g, b);
	gfx.PutPixel(x + 27, y + 27, r, g, b);
	gfx.PutPixel(x + 28, y + 28, r, g, b);
	gfx.PutPixel(x + 29, y + 29, r, g, b);
	//	diagonal top right-bottom left
	gfx.PutPixel(x + 1 , y + 29, r, g, b);
	gfx.PutPixel(x + 2 , y + 28, r, g, b);
	gfx.PutPixel(x + 3 , y + 27, r, g, b);
	gfx.PutPixel(x + 4 , y + 26, r, g, b);
	gfx.PutPixel(x + 5 , y + 25, r, g, b);
	gfx.PutPixel(x + 6 , y + 24, r, g, b);
	gfx.PutPixel(x + 7 , y + 23, r, g, b);
	gfx.PutPixel(x + 8 , y + 22, r, g, b);
	gfx.PutPixel(x + 9 , y + 21, r, g, b);
	gfx.PutPixel(x + 10, y + 20, r, g, b);
	gfx.PutPixel(x + 11, y + 19, r, g, b);
	gfx.PutPixel(x + 12, y + 18, r, g, b);
	gfx.PutPixel(x + 13, y + 17, r, g, b);
	gfx.PutPixel(x + 14, y + 16, r, g, b);
	gfx.PutPixel(x + 15, y + 15, r, g, b);
	gfx.PutPixel(x + 16, y + 14, r, g, b);
	gfx.PutPixel(x + 17, y + 13, r, g, b);
	gfx.PutPixel(x + 18, y + 12, r, g, b);
	gfx.PutPixel(x + 19, y + 11, r, g, b);
	gfx.PutPixel(x + 20, y + 10, r, g, b);
	gfx.PutPixel(x + 21, y + 9 , r, g, b);
	gfx.PutPixel(x + 22, y + 8 , r, g, b);
	gfx.PutPixel(x + 23, y + 7 , r, g, b);
	gfx.PutPixel(x + 24, y + 6 , r, g, b);
	gfx.PutPixel(x + 25, y + 5 , r, g, b);
	gfx.PutPixel(x + 26, y + 4 , r, g, b);
	gfx.PutPixel(x + 27, y + 3 , r, g, b);
	gfx.PutPixel(x + 28, y + 2 , r, g, b);
	gfx.PutPixel(x + 29, y + 1 , r, g, b);
}

void Game::Obstacle_C()
{
	if (Lives > 0)
	{
		Obstacle(ObstacleX1 , ObstacleY1 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX2 , ObstacleY2 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX3 , ObstacleY3 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX4 , ObstacleY4 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX5 , ObstacleY5 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX6 , ObstacleY6 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX7 , ObstacleY7 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX8 , ObstacleY8 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX9 , ObstacleY9 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX10, ObstacleY10, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX11, ObstacleY11, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX12, ObstacleY12, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX13, ObstacleY13, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX14, ObstacleY14, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX15, ObstacleY15, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX16, ObstacleY16, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX17, ObstacleY17, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX18, ObstacleY18, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX19, ObstacleY19, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX10, ObstacleY10, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX11, ObstacleY11, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX12, ObstacleY12, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX13, ObstacleY13, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX14, ObstacleY14, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX15, ObstacleY15, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX16, ObstacleY16, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX17, ObstacleY17, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX18, ObstacleY18, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX19, ObstacleY19, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX20, ObstacleY20, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX21, ObstacleY21, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX22, ObstacleY22, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX23, ObstacleY23, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX24, ObstacleY24, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX25, ObstacleY25, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX26, ObstacleY26, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX27, ObstacleY27, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX28, ObstacleY28, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX29, ObstacleY29, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX30, ObstacleY30, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX31, ObstacleY31, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX32, ObstacleY32, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX33, ObstacleY33, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX34, ObstacleY34, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX35, ObstacleY35, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX36, ObstacleY36, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX37, ObstacleY37, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX38, ObstacleY38, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX39, ObstacleY39, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX40, ObstacleY40, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX41, ObstacleY41, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX42, ObstacleY42, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX43, ObstacleY43, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX44, ObstacleY44, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX45, ObstacleY45, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX46, ObstacleY46, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX47, ObstacleY47, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX48, ObstacleY48, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX49, ObstacleY49, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX50, ObstacleY50, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX51, ObstacleY51, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX52, ObstacleY52, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX53, ObstacleY53, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX54, ObstacleY54, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX55, ObstacleY55, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX56, ObstacleY56, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX57, ObstacleY57, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX58, ObstacleY58, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX59, ObstacleY59, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		Obstacle(ObstacleX60, ObstacleY60, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		if (isHardMode)
		{
			Obstacle(ObstacleX61 , ObstacleY61 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX62 , ObstacleY62 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX63 , ObstacleY63 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX64 , ObstacleY64 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX65 , ObstacleY65 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX66 , ObstacleY66 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX67 , ObstacleY67 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX68 , ObstacleY68 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX69 , ObstacleY69 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX70 , ObstacleY70 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX71 , ObstacleY71 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX72 , ObstacleY72 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX73 , ObstacleY73 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX74 , ObstacleY74 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX75 , ObstacleY75 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX76 , ObstacleY76 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX77 , ObstacleY77 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX78 , ObstacleY78 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX79 , ObstacleY79 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX80 , ObstacleY80 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX81 , ObstacleY81 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX82 , ObstacleY82 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX83 , ObstacleY83 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX84 , ObstacleY84 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX85 , ObstacleY85 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX86 , ObstacleY86 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX87 , ObstacleY87 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX88 , ObstacleY88 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX89 , ObstacleY89 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX90 , ObstacleY90 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX91 , ObstacleY91 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX92 , ObstacleY92 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX93 , ObstacleY93 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX94 , ObstacleY94 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX95 , ObstacleY95 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX96 , ObstacleY96 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX97 , ObstacleY97 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX98 , ObstacleY98 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX99 , ObstacleY99 , ObstacleRGB, ObstacleRGB, ObstacleRGB);
			Obstacle(ObstacleX100, ObstacleY100, ObstacleRGB, ObstacleRGB, ObstacleRGB);
		}
	}
}

void Game::ObstacleCheck(int dx, int dy, int dw, int bx, int by, int bw, int ox, int oy, int ow)
{
	if ((dx + dw >= ox && dx <= ox + ow && dy + dw >= oy && dy <= oy + ow) || (bx + bw >= ox && bx <= ox + ow && by + bw >= oy && by <= oy + ow))
	{
		isAgainstBorder = true;
	}
}

void Game::ObstacleCheck_C()
{
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX1 , ObstacleY1 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX2 , ObstacleY2 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX3 , ObstacleY3 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX4 , ObstacleY4 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX5 , ObstacleY5 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX6 , ObstacleY6 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX7 , ObstacleY7 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX8 , ObstacleY8 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX9 , ObstacleY9 , ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX10, ObstacleY10, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX11, ObstacleY11, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX12, ObstacleY12, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX13, ObstacleY13, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX14, ObstacleY14, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX15, ObstacleY15, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX16, ObstacleY16, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX17, ObstacleY17, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX18, ObstacleY18, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX19, ObstacleY19, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX20, ObstacleY20, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX21, ObstacleY21, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX22, ObstacleY22, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX23, ObstacleY23, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX24, ObstacleY24, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX25, ObstacleY25, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX26, ObstacleY26, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX27, ObstacleY27, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX28, ObstacleY28, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX29, ObstacleY29, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX30, ObstacleY30, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX31, ObstacleY31, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX32, ObstacleY32, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX33, ObstacleY33, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX34, ObstacleY34, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX35, ObstacleY35, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX36, ObstacleY36, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX37, ObstacleY37, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX38, ObstacleY38, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX39, ObstacleY39, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX40, ObstacleY40, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX41, ObstacleY41, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX42, ObstacleY42, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX43, ObstacleY43, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX44, ObstacleY44, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX45, ObstacleY45, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX46, ObstacleY46, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX47, ObstacleY47, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX48, ObstacleY48, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX49, ObstacleY49, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX50, ObstacleY50, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX51, ObstacleY51, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX52, ObstacleY52, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX53, ObstacleY53, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX54, ObstacleY54, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX55, ObstacleY55, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX56, ObstacleY56, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX57, ObstacleY57, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX58, ObstacleY58, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX59, ObstacleY59, ObstacleW);
	ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX60, ObstacleY60, ObstacleW);
	if (isHardMode)
	{
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX61 , ObstacleY61 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX62 , ObstacleY62 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX63 , ObstacleY63 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX64 , ObstacleY64 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX65 , ObstacleY65 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX66 , ObstacleY66 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX67 , ObstacleY67 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX68 , ObstacleY68 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX69 , ObstacleY69 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX70 , ObstacleY70 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX71 , ObstacleY71 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX72 , ObstacleY72 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX73 , ObstacleY73 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX74 , ObstacleY74 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX75 , ObstacleY75 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX76 , ObstacleY76 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX77 , ObstacleY77 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX78 , ObstacleY78 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX79 , ObstacleY79 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX80 , ObstacleY80 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX81 , ObstacleY81 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX82 , ObstacleY82 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX83 , ObstacleY83 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX84 , ObstacleY84 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX85 , ObstacleY85 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX86 , ObstacleY86 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX87 , ObstacleY87 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX88 , ObstacleY88 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX89 , ObstacleY89 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX90 , ObstacleY90 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX91 , ObstacleY91 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX92 , ObstacleY92 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX93 , ObstacleY93 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX94 , ObstacleY94 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX95 , ObstacleY95 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX96 , ObstacleY96 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX97 , ObstacleY97 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX98 , ObstacleY98 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX99 , ObstacleY99 , ObstacleW);
		ObstacleCheck(DudeX, DudeY, DudeW, BossX, BossY, BossW, ObstacleX100, ObstacleY100, ObstacleW);
	}
}

void Game::RandomizeObstacle(int &x, int &y, int w, int rgb)
{
	if (isSuccessful == true || isInitialized == false)
	{
		x = rand() % 769;
		y = rand() % 569;
//		isSuccessful = false; (I put this in RandomizeObstacle_C so that it only activates once ALL have been randomized)
	}

	while ((y + w > 540 && x < 50 + DudeW) || (x + w > BossX - 20 && x < BossX + BossW + 20 && y + w > BossY - 20 && y < BossY + BossW + 20))
	{
		x = rand() % 769;
		y = rand() % 569;
	}
}

void Game::RandomizeObstacle_C()
{
	//There is extra code at the bottom
	RandomizeObstacle(ObstacleX1 , ObstacleY1 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX2 , ObstacleY2 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX3 , ObstacleY3 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX4 , ObstacleY4 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX5 , ObstacleY5 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX6 , ObstacleY6 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX7 , ObstacleY7 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX8 , ObstacleY8 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX9 , ObstacleY9 , ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX10, ObstacleY10, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX11, ObstacleY11, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX12, ObstacleY12, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX13, ObstacleY13, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX14, ObstacleY14, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX15, ObstacleY15, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX16, ObstacleY16, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX17, ObstacleY17, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX18, ObstacleY18, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX19, ObstacleY19, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX20, ObstacleY20, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX21, ObstacleY21, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX22, ObstacleY22, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX23, ObstacleY23, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX24, ObstacleY24, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX25, ObstacleY25, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX26, ObstacleY26, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX27, ObstacleY27, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX28, ObstacleY28, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX29, ObstacleY29, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX30, ObstacleY30, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX31, ObstacleY31, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX32, ObstacleY32, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX33, ObstacleY33, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX34, ObstacleY34, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX35, ObstacleY35, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX36, ObstacleY36, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX37, ObstacleY37, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX38, ObstacleY38, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX39, ObstacleY39, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX40, ObstacleY40, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX41, ObstacleY41, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX42, ObstacleY42, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX43, ObstacleY43, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX44, ObstacleY44, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX45, ObstacleY45, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX46, ObstacleY46, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX47, ObstacleY47, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX48, ObstacleY48, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX49, ObstacleY49, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX50, ObstacleY50, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX51, ObstacleY51, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX52, ObstacleY52, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX53, ObstacleY53, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX54, ObstacleY54, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX55, ObstacleY55, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX56, ObstacleY56, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX57, ObstacleY57, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX58, ObstacleY58, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX59, ObstacleY59, ObstacleW, ObstacleRGB);
	RandomizeObstacle(ObstacleX60, ObstacleY60, ObstacleW, ObstacleRGB);
	if (isHardMode)
	{
		RandomizeObstacle(ObstacleX61 , ObstacleY61 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX62 , ObstacleY62 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX63 , ObstacleY63 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX64 , ObstacleY64 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX65 , ObstacleY65 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX66 , ObstacleY66 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX67 , ObstacleY67 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX68 , ObstacleY68 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX69 , ObstacleY69 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX70 , ObstacleY70 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX71 , ObstacleY71 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX72 , ObstacleY72 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX73 , ObstacleY73 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX74 , ObstacleY74 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX75 , ObstacleY75 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX76 , ObstacleY76 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX77 , ObstacleY77 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX78 , ObstacleY78 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX79 , ObstacleY79 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX80 , ObstacleY80 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX81 , ObstacleY81 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX82 , ObstacleY82 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX83 , ObstacleY83 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX84 , ObstacleY84 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX85 , ObstacleY85 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX86 , ObstacleY86 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX87 , ObstacleY87 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX88 , ObstacleY88 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX89 , ObstacleY89 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX90 , ObstacleY90 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX91 , ObstacleY91 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX92 , ObstacleY92 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX93 , ObstacleY93 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX94 , ObstacleY94 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX95 , ObstacleY95 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX96 , ObstacleY96 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX97 , ObstacleY97 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX98 , ObstacleY98 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX99 , ObstacleY99 , ObstacleW, ObstacleRGB);
		RandomizeObstacle(ObstacleX100, ObstacleY100, ObstacleW, ObstacleRGB);
	}

	isSuccessful = false;
}

void Game::InitializeObstacle()
{
	if (isInitialized == false)
	{
		RandomizeObstacle_C();
		isHardMode = false;

		isInitialized = true;
	}
}

void Game::PointCounter()
{
	if (isSuccessful && TeleportStage == 0)
	{
		Points++;
	}


}

void Game::LifeCounter()
{
	//0 Lives turns off movement, and Draw function for Dude, Boss, Obstacles
	if (isAgainstBorder == true && isSuccessful == false && TeleportStage == 0)
	{
		Lives--;
	}
	if (isAgainstBorder == true && isSuccessful && TeleportStage == 0)
	{
		Lives++;
	}

	if (Lives > 3)
	{
		Lives = 3;
	}
}

void Game::HardMode()
{
	if (isFingerLifted == false && !(wnd.kbd.KeyIsPressed(VK_RETURN))) //This is here so it doesn't flash back and forth between hard/easy mode 60 times a second
	{
		isFingerLifted = true;
	}
	if (wnd.kbd.KeyIsPressed(VK_RETURN) && isHardMode == false && isFingerLifted)
	{
		isHardMode = true;
		isFingerLifted = false;

	}
	if (wnd.kbd.KeyIsPressed(VK_RETURN) && isHardMode && isFingerLifted)
	{
		isHardMode = false;
		isFingerLifted = false;
	}
}

void Game::GameOver(int x, int y)
{
	if (Lives == 0)
	{
		gfx.PutPixel(14 + x, 0 + y, 138, 77, 0);
		gfx.PutPixel(7 + x, 1 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 1 + y, 138, 77, 0);
		gfx.PutPixel(20 + x, 1 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 2 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 2 + y, 138, 77, 0);
		gfx.PutPixel(20 + x, 2 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 3 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 4 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 4 + y, 138, 77, 0);
		gfx.PutPixel(21 + x, 4 + y, 138, 77, 0);
		gfx.PutPixel(7 + x, 5 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 5 + y, 138, 77, 0);
		gfx.PutPixel(21 + x, 5 + y, 138, 77, 0);
		gfx.PutPixel(7 + x, 6 + y, 138, 77, 0);
		gfx.PutPixel(20 + x, 6 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 7 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 7 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 7 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 7 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 8 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 8 + y, 51, 28, 0);
		gfx.PutPixel(14 + x, 8 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 9 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 9 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 9 + y, 102, 57, 0);
		gfx.PutPixel(13 + x, 9 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 9 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 9 + y, 51, 28, 0);
		gfx.PutPixel(21 + x, 9 + y, 138, 77, 0);
		gfx.PutPixel(10 + x, 10 + y, 51, 28, 0);
		gfx.PutPixel(11 + x, 10 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 10 + y, 102, 57, 0);
		gfx.PutPixel(13 + x, 10 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 10 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 10 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 10 + y, 138, 77, 0);
		gfx.PutPixel(9 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 11 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 11 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(14 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(16 + x, 11 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 12 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 12 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 12 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 12 + y, 111, 62, 0);
		gfx.PutPixel(13 + x, 12 + y, 102, 57, 0);
		gfx.PutPixel(14 + x, 12 + y, 102, 57, 0);
		gfx.PutPixel(15 + x, 12 + y, 102, 57, 0);
		gfx.PutPixel(16 + x, 12 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 13 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 13 + y, 109, 61, 0);
		gfx.PutPixel(11 + x, 13 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 13 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 13 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 13 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 13 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 13 + y, 51, 28, 0);
		gfx.PutPixel(5 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(8 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(11 + x, 14 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 14 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 14 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 14 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 14 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 14 + y, 51, 28, 0);
		gfx.PutPixel(4 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(5 + x, 15 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 15 + y, 116, 65, 0);
		gfx.PutPixel(8 + x, 15 + y, 138, 77, 0);
		gfx.PutPixel(9 + x, 15 + y, 138, 77, 0);
		gfx.PutPixel(10 + x, 15 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(14 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(16 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(17 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(18 + x, 15 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(2 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(3 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(4 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(5 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 16 + y, 116, 65, 0);
		gfx.PutPixel(8 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(9 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(10 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 16 + y, 109, 61, 0);
		gfx.PutPixel(14 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(17 + x, 16 + y, 138, 77, 0);
		gfx.PutPixel(18 + x, 16 + y, 123, 69, 0);
		gfx.PutPixel(19 + x, 16 + y, 51, 28, 0);
		gfx.PutPixel(0 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 17 + y, 87, 49, 0);
		gfx.PutPixel(2 + x, 17 + y, 87, 49, 0);
		gfx.PutPixel(3 + x, 17 + y, 87, 49, 0);
		gfx.PutPixel(4 + x, 17 + y, 87, 49, 0);
		gfx.PutPixel(5 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(6 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 17 + y, 43, 24, 0);
		gfx.PutPixel(8 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(11 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 17 + y, 40, 22, 0);
		gfx.PutPixel(14 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 17 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 17 + y, 138, 77, 0);
		gfx.PutPixel(17 + x, 17 + y, 138, 77, 0);
		gfx.PutPixel(18 + x, 17 + y, 123, 69, 0);
		gfx.PutPixel(19 + x, 17 + y, 51, 28, 0);
		gfx.PutPixel(0 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(2 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(3 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(4 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(5 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(6 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(8 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(11 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(14 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(17 + x, 18 + y, 138, 77, 0);
		gfx.PutPixel(18 + x, 18 + y, 123, 69, 0);
		gfx.PutPixel(19 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(21 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(22 + x, 18 + y, 51, 28, 0);
		gfx.PutPixel(0 + x, 19 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(2 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(3 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(4 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(5 + x, 19 + y, 51, 28, 0);
		gfx.PutPixel(6 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(7 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(8 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(9 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(10 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(17 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(18 + x, 19 + y, 123, 69, 0);
		gfx.PutPixel(19 + x, 19 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(21 + x, 19 + y, 138, 77, 0);
		gfx.PutPixel(22 + x, 19 + y, 65, 36, 0);
		gfx.PutPixel(23 + x, 19 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(2 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(3 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(4 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(5 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(6 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(7 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(8 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(9 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(10 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(11 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(12 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(13 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(14 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(15 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(16 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(17 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(18 + x, 20 + y, 123, 69, 0);
		gfx.PutPixel(19 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(21 + x, 20 + y, 138, 77, 0);
		gfx.PutPixel(22 + x, 20 + y, 65, 36, 0);
		gfx.PutPixel(23 + x, 20 + y, 51, 28, 0);
		gfx.PutPixel(0 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 21 + y, 138, 77, 0);
		gfx.PutPixel(2 + x, 21 + y, 138, 77, 0);
		gfx.PutPixel(3 + x, 21 + y, 138, 77, 0);
		gfx.PutPixel(4 + x, 21 + y, 138, 77, 0);
		gfx.PutPixel(5 + x, 21 + y, 138, 77, 0);
		gfx.PutPixel(6 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(7 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(8 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(9 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(10 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(11 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(12 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(13 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(14 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(15 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(16 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(17 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(18 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(20 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(21 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(22 + x, 21 + y, 51, 28, 0);
		gfx.PutPixel(0 + x, 22 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 22 + y, 65, 36, 0);
		gfx.PutPixel(2 + x, 22 + y, 65, 36, 0);
		gfx.PutPixel(3 + x, 22 + y, 65, 36, 0);
		gfx.PutPixel(4 + x, 22 + y, 65, 36, 0);
		gfx.PutPixel(5 + x, 22 + y, 65, 36, 0);
		gfx.PutPixel(6 + x, 22 + y, 51, 28, 0);
		gfx.PutPixel(1 + x, 23 + y, 51, 28, 0);
		gfx.PutPixel(2 + x, 23 + y, 51, 28, 0);
		gfx.PutPixel(3 + x, 23 + y, 51, 28, 0);
		gfx.PutPixel(4 + x, 23 + y, 51, 28, 0);
		gfx.PutPixel(5 + x, 23 + y, 51, 28, 0);
		gfx.PutPixel(6 + x, 23 + y, 51, 28, 0);
	}
}

void Game::DudeColourAssign()
{
	//Most of the code takes place in Teleport. This is just the check to see what it should change the value of DudeColour_Ass to, for the fade in.
	if (Lives == 3)
	{
		DudeG_Ass = 23;
	}
	if (Lives == 2)
	{
		DudeG_Ass = 16;
	}
	if (Lives == 1)
	{
		DudeG_Ass = 10;
	}
}

void Game::UpdateModel()
{
	//Initialization (Because I don't want to fuck around and put code in header file)
	InitializeObstacle();
	HardMode();

	//Character movement
	Running();
	Exhaustion();
	Movement(DudeX, DudeY);

	//Boss movement
	BossMovement_C();

	//Screen borders
	Borders(DudeX, DudeY, DudeW);
	Borders(BossX, BossY, BossW);
	BorderCheck(BossX, BossY, BossW);
	ObstacleCheck_C();

	//Extra functionality
	PointCounter();
	LifeCounter();
	Teleport();
//	RandomizeObstacle_C (Hidden inside of Teleport)
//	DudeColourAssign (Hidden inside of Teleport)
}

void Game::ComposeFrame()
{
	Dude(DudeX, DudeY, DudeR, DudeG, DudeB);
	Boss(BossX, BossY, BossR, BossG, BossB);
	Obstacle_C();
	GameOver(390, 290);
}
