/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.h																				  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#pragma once

#include "Keyboard.h"
#include "Mouse.h"
#include "Graphics.h"

class Game
{
public:
	Game( class MainWindow& wnd );
	Game( const Game& ) = delete;
	Game& operator=( const Game& ) = delete;
	void Go();
private:
	void ComposeFrame();
	void UpdateModel();
	/********************************/
	/*  User Functions              */
	void Dude(int x, int y, int r, int g, int b);
	void Movement(int &x, int &y);
	void Exhaustion();
	void Running();
	void Borders(int &x, int &y, int w);
	void Boss(int x, int y, int r, int g, int b);
	void BossMovement(int dx, int dy, int &bx, int &by, int dw, int bw, int rad);
	void BossMovement_C();
	void Teleport();
	void BorderCheck(int x, int y, int w);
	void Obstacle(int x, int y, int r, int g, int b);
	void Obstacle_C();
	void ObstacleCheck(int dx, int dy, int dw, int bx, int by, int bw, int ox, int oy, int ow);
	void ObstacleCheck_C();
	void RandomizeObstacle(int &x, int &y, int w, int rgb);
	void RandomizeObstacle_C();
	void InitializeObstacle();
	void PointCounter();
	void LifeCounter();
	void HardMode();
	void GameOver(int x, int y);
	void DudeColourAssign();
	/********************************/
private:
	MainWindow& wnd;
	Graphics gfx;
	/********************************/
	/*  User Variables              */
	int DudeX = 45;
	int DudeY = 545;
	int DudeR = 230;
	int DudeG = 230;
	int DudeB = 100;
	int DudeW = 9;
	int BossX = 391;
	int BossY = 291;
	int BossR = 160;
	int BossG = 30;
	int BossB = 240;
	int BossW = 17;
	int Speed;
	int RunLength = 0;
	bool isRunning = false;
	bool isExhausted = false;
	int ExhaustedStage = 0;
	bool isReady = true;
	bool isAgainstBorder = false;
	int TeleportStage = 0;
	int ObstacleW = 30;
	int ObstacleRGB = 200;
	bool isSuccessful = false;
	bool isInitialized = false;
	int Points = 0; 
	int Lives = 3;
	bool isHardMode = true; //(This is just so it initialises ALL boxes through RandomizeObstacle_C. HardMode is turned right back off in InitializeObstacle)
	bool isFingerLifted = true;
	int DudeR_Ass;
	int DudeG_Ass;
	int DudeB_Ass;


	//initialized in Game.cpp under InitializeObstacle
	int ObstacleX1 /* = rand() % 769*/;
	int ObstacleY1 /* = rand() % 569*/;
	int ObstacleX2 /* = rand() % 769*/;
	int ObstacleY2 /* = rand() % 569*/;
	int ObstacleX3 /* = rand() % 769*/;
	int ObstacleY3 /* = rand() % 569*/;
	int ObstacleX4 /* = rand() % 769*/;
	int ObstacleY4 /* = rand() % 569*/;
	int ObstacleX5 /* = rand() % 769*/;
	int ObstacleY5 /* = rand() % 569*/;
	int ObstacleX6 /* = rand() % 769*/;
	int ObstacleY6 /* = rand() % 569*/;
	int ObstacleX7 /* = rand() % 769*/;
	int ObstacleY7 /* = rand() % 569*/;
	int ObstacleX8 /* = rand() % 769*/;
	int ObstacleY8 /* = rand() % 569*/;
	int ObstacleX9 /* = rand() % 769*/;
	int ObstacleY9 /* = rand() % 569*/;
	int ObstacleX10/* = rand() % 769*/;
	int ObstacleY10/* = rand() % 569*/;
	int ObstacleX11/* = rand() % 769*/;
	int ObstacleY11/* = rand() % 569*/;
	int ObstacleX12/* = rand() % 769*/;
	int ObstacleY12/* = rand() % 569*/;
	int ObstacleX13/* = rand() % 769*/;
	int ObstacleY13/* = rand() % 569*/;
	int ObstacleX14/* = rand() % 769*/;
	int ObstacleY14/* = rand() % 569*/;
	int ObstacleX15/* = rand() % 769*/;
	int ObstacleY15/* = rand() % 569*/;
	int ObstacleX16/* = rand() % 769*/;
	int ObstacleY16/* = rand() % 569*/;
	int ObstacleX17/* = rand() % 769*/;
	int ObstacleY17/* = rand() % 569*/;
	int ObstacleX18/* = rand() % 769*/;
	int ObstacleY18/* = rand() % 569*/;
	int ObstacleX19/* = rand() % 769*/;
	int ObstacleY19/* = rand() % 569*/;
	int ObstacleX20/* = rand() % 769*/;
	int ObstacleY20/* = rand() % 569*/;
	int ObstacleX21/* = rand() % 769*/;
	int ObstacleY21/* = rand() % 569*/;
	int ObstacleX22/* = rand() % 769*/;
	int ObstacleY22/* = rand() % 569*/;
	int ObstacleX23/* = rand() % 769*/;
	int ObstacleY23/* = rand() % 569*/;
	int ObstacleX24/* = rand() % 769*/;
	int ObstacleY24/* = rand() % 569*/;
	int ObstacleX25/* = rand() % 769*/;
	int ObstacleY25/* = rand() % 569*/;
	int ObstacleX26/* = rand() % 769*/;
	int ObstacleY26/* = rand() % 569*/;
	int ObstacleX27/* = rand() % 769*/;
	int ObstacleY27/* = rand() % 569*/;
	int ObstacleX28/* = rand() % 769*/;
	int ObstacleY28/* = rand() % 569*/;
	int ObstacleX29/* = rand() % 769*/;
	int ObstacleY29/* = rand() % 569*/;
	int ObstacleX30/* = rand() % 769*/;
	int ObstacleY30/* = rand() % 569*/;
	int ObstacleX31/* = rand() % 769*/;
	int ObstacleY31/* = rand() % 569*/;
	int ObstacleX32/* = rand() % 769*/;
	int ObstacleY32/* = rand() % 569*/;
	int ObstacleX33/* = rand() % 769*/;
	int ObstacleY33/* = rand() % 569*/;
	int ObstacleX34/* = rand() % 769*/;
	int ObstacleY34/* = rand() % 569*/;
	int ObstacleX35/* = rand() % 769*/;
	int ObstacleY35/* = rand() % 569*/;
	int ObstacleX36/* = rand() % 769*/;
	int ObstacleY36/* = rand() % 569*/;
	int ObstacleX37/* = rand() % 769*/;
	int ObstacleY37/* = rand() % 569*/;
	int ObstacleX38/* = rand() % 769*/;
	int ObstacleY38/* = rand() % 569*/;
	int ObstacleX39/* = rand() % 769*/;
	int ObstacleY39/* = rand() % 569*/;
	int ObstacleX40/* = rand() % 769*/;
	int ObstacleY40/* = rand() % 569*/;
	int ObstacleX41/* = rand() % 769*/;
	int ObstacleY41/* = rand() % 569*/;
	int ObstacleX42/* = rand() % 769*/;
	int ObstacleY42/* = rand() % 569*/;
	int ObstacleX43/* = rand() % 769*/;
	int ObstacleY43/* = rand() % 569*/;
	int ObstacleX44/* = rand() % 769*/;
	int ObstacleY44/* = rand() % 569*/;
	int ObstacleX45/* = rand() % 769*/;
	int ObstacleY45/* = rand() % 569*/;
	int ObstacleX46/* = rand() % 769*/;
	int ObstacleY46/* = rand() % 569*/;
	int ObstacleX47/* = rand() % 769*/;
	int ObstacleY47/* = rand() % 569*/;
	int ObstacleX48/* = rand() % 769*/;
	int ObstacleY48/* = rand() % 569*/;
	int ObstacleX49/* = rand() % 769*/;
	int ObstacleY49/* = rand() % 569*/;
	int ObstacleX50/* = rand() % 769*/;
	int ObstacleY50/* = rand() % 569*/;
	int ObstacleX51/* = rand() % 769*/;
	int ObstacleY51/* = rand() % 569*/;
	int ObstacleX52/* = rand() % 769*/;
	int ObstacleY52/* = rand() % 569*/;
	int ObstacleX53/* = rand() % 769*/;
	int ObstacleY53/* = rand() % 569*/;
	int ObstacleX54/* = rand() % 769*/;
	int ObstacleY54/* = rand() % 569*/;
	int ObstacleX55/* = rand() % 769*/;
	int ObstacleY55/* = rand() % 569*/;
	int ObstacleX56/* = rand() % 769*/;
	int ObstacleY56/* = rand() % 569*/;
	int ObstacleX57/* = rand() % 769*/;
	int ObstacleY57/* = rand() % 569*/;
	int ObstacleX58/* = rand() % 769*/;
	int ObstacleY58/* = rand() % 569*/;
	int ObstacleX59/* = rand() % 769*/;
	int ObstacleY59/* = rand() % 569*/;
	int ObstacleX60/* = rand() % 769*/;
	int ObstacleY60/* = rand() % 569*/;
	int ObstacleX61/* = rand() % 769*/;
	int ObstacleY61/* = rand() % 569*/;
	int ObstacleX62/* = rand() % 769*/;
	int ObstacleY62/* = rand() % 569*/;
	int ObstacleX63/* = rand() % 769*/;
	int ObstacleY63/* = rand() % 569*/;
	int ObstacleX64/* = rand() % 769*/;
	int ObstacleY64/* = rand() % 569*/;
	int ObstacleX65/* = rand() % 769*/;
	int ObstacleY65/* = rand() % 569*/;
	int ObstacleX66/* = rand() % 769*/;
	int ObstacleY66/* = rand() % 569*/;
	int ObstacleX67/* = rand() % 769*/;
	int ObstacleY67/* = rand() % 569*/;
	int ObstacleX68/* = rand() % 769*/;
	int ObstacleY68/* = rand() % 569*/;
	int ObstacleX69/* = rand() % 769*/;
	int ObstacleY69/* = rand() % 569*/;
	int ObstacleX70/* = rand() % 769*/;
	int ObstacleY70/* = rand() % 569*/;
	int ObstacleX71/* = rand() % 769*/;
	int ObstacleY71/* = rand() % 569*/;
	int ObstacleX72/* = rand() % 769*/;
	int ObstacleY72/* = rand() % 569*/;
	int ObstacleX73/* = rand() % 769*/;
	int ObstacleY73/* = rand() % 569*/;
	int ObstacleX74/* = rand() % 769*/;
	int ObstacleY74/* = rand() % 569*/;
	int ObstacleX75/* = rand() % 769*/;
	int ObstacleY75/* = rand() % 569*/;
	int ObstacleX76/* = rand() % 769*/;
	int ObstacleY76/* = rand() % 569*/;
	int ObstacleX77/* = rand() % 769*/;
	int ObstacleY77/* = rand() % 569*/;
	int ObstacleX78/* = rand() % 769*/;
	int ObstacleY78/* = rand() % 569*/;
	int ObstacleX79/* = rand() % 769*/;
	int ObstacleY79/* = rand() % 569*/;
	int ObstacleX80/* = rand() % 769*/;
	int ObstacleY80/* = rand() % 569*/;
	int ObstacleX81/* = rand() % 769*/;
	int ObstacleY81/* = rand() % 569*/;
	int ObstacleX82/* = rand() % 769*/;
	int ObstacleY82/* = rand() % 569*/;
	int ObstacleX83/* = rand() % 769*/;
	int ObstacleY83/* = rand() % 569*/;
	int ObstacleX84/* = rand() % 769*/;
	int ObstacleY84/* = rand() % 569*/;
	int ObstacleX85/* = rand() % 769*/;
	int ObstacleY85/* = rand() % 569*/;
	int ObstacleX86/* = rand() % 769*/;
	int ObstacleY86/* = rand() % 569*/;
	int ObstacleX87/* = rand() % 769*/;
	int ObstacleY87/* = rand() % 569*/;
	int ObstacleX88/* = rand() % 769*/;
	int ObstacleY88/* = rand() % 569*/;
	int ObstacleX89/* = rand() % 769*/;
	int ObstacleY89/* = rand() % 569*/;
	int ObstacleX90/* = rand() % 769*/;
	int ObstacleY90/* = rand() % 569*/;
	int ObstacleX91/* = rand() % 769*/;
	int ObstacleY91/* = rand() % 569*/;
	int ObstacleX92/* = rand() % 769*/;
	int ObstacleY92/* = rand() % 569*/;
	int ObstacleX93/* = rand() % 769*/;
	int ObstacleY93/* = rand() % 569*/;
	int ObstacleX94/* = rand() % 769*/;
	int ObstacleY94/* = rand() % 569*/;
	int ObstacleX95/* = rand() % 769*/;
	int ObstacleY95/* = rand() % 569*/;
	int ObstacleX96/* = rand() % 769*/;
	int ObstacleY96/* = rand() % 569*/;
	int ObstacleX97/* = rand() % 769*/;
	int ObstacleY97/* = rand() % 569*/;
	int ObstacleX98/* = rand() % 769*/;
	int ObstacleY98/* = rand() % 569*/;
	int ObstacleX99/* = rand() % 769*/;
	int ObstacleY99/* = rand() % 569*/;
	int ObstacleX100/* = rand() % 769*/;
	int ObstacleY100/* = rand() % 569*/;
	/********************************/
};